<!DOCTYPE html>
<html lang="en">

<head>
  <link rel="stylesheet"
        href="https://cdnjs.cloudflare.com/ajax/libs/semantic-ui/2.4.1/semantic.min.css">
</head>

<body>

  <div id="app" class="ui container">
    <h1>GitHub Profiles</h1>
    <div class="ui cards">
      <github-user-card v-for="user in usernames" :username="user"></github-user-card>
    </div>
  </div>

  <!-- Import Vue.js and axios -->
  <script src="https://unpkg.com/vue"></script>
  <script src="https://unpkg.com/axios/dist/axios.min.js"></script>

  <script type="text/x-template" id="github-user-card-template">
    <div class="ui card">
      <div class="image">
        <img :src="user.avatar_url">
      </div>
      
      <div class="content">
        <a class="header" :href="user.html_url" target="_blank">{{ user.name }}</a>
        <div class="meta">
          <span class="date">Joined in {{ createdAtYear }}</span>
        </div>
        <div class="description">
          {{ user.bio }}
        </div>
      </div>
      
      <div class="extra content">
        <a :href="`https://github.com/${username}?tab=followers`" target="_blank">
          <i class="user icon"></i>
          {{ user.followers }} followers
        </a>
      </div>
    </div>
  </script>
  
  <!-- Your JavaScript Code :) -->
  <!-- https://api.github.com/users/alibitek -->
  <script>
    Vue.component('github-user-card', {
      template: '#github-user-card-template',            
      
      props: {
        username: {
          type: String,
          required: true,
        },
      },
      
      data: function () {
        return {
          user: {},
        };
      },    
      
      methods: {
        fetchProfileData () {
          console.log("Fetching data for username", this.username);
          axios
            .get(`https://api.github.com/users/${this.username}`)
            .then((response) => this.user = response.data )
            .catch(error => console.error(error))
            .finally(() => console.log("Profile data for:", this.username, this.user)); 
        }
      },
      
      computed: {
        createdAtYear() {
          return new Date(this.user.created_at).getFullYear();
        },
      },
      
      created () {
        this.fetchProfileData();
      },    
    });
  
    new Vue({
      el: '#app',
      data: {
        usernames: ['alibitek', 'vampy', 'yyx990803'],
      },
    })
  </script>
</body>

</html>  
